<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{basePath}/svg-inject.min.js"></script>
    <script src="{basePath}/jquery-3.5.1.min.js"></script>
    <link rel="stylesheet" href="{basePath}/common.css">
    <link rel="stylesheet" href="{basePath}/disassemblerViewDark.css">
    <link rel="stylesheet" href="{basePath}/bootstrap-4.5.2-dist/css/bootstrap.css">
</head>

<body>
    <div class="loadingContainer">
        <img src="{basePath}/../../resources/dark/loading.svg" style="stroke: white;" onload="SVGInject(this)" />
    </div>
    <div class="container-fluid">
        <div class="row" style="margin-top: 5px; margin-bottom: 5px;">
            <div class="col">
                <nav class="navbar navbar-inverse navbar-fixed-top justify-content-start">
                    <input id="address" class="form-control" style="width: 150px; float: left; margin-right: 5px;" value="0x8000000" />
                    <button id="button" type="button" class="btn btn-primary" onclick='disassemble()' disabled>Go</button>
                    <input id="search_ins" type="text" class="form-control" style="display: inline; width: 150px;  margin-right: 5px;">
                    <button id="search_button" type="button" class="btn btn-primary" onclick='search_ins()' disabled>Search</button>
                    <label for="From">From&nbsp;</label>
                    <input id="startAddress" type="text" class="form-control" style="display: inline; width: 150px; margin-right: 5px;">
                    <label for="End" style="display: inline;">To&nbsp;</label>
                    <input id="endAddress" type="text" class="form-control" style="display: inline; width: 150px;  margin-right: 5px;">
                </nav>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <div class="container-fluid" id="data"></div>
            </div>
        </div>
    </div>

    <script>
        const vscode = acquireVsCodeApi();

        window.addEventListener('message', event => {
            const message = event.data;
            switch (message.type) {
                case 'refactor':
                    document.getElementById('peter').innerHTML = message.myData;
                    break;
                case 'start':
                    $('.loadingContainer').css('display', 'none');
                    document.getElementById('button').disabled = false;
                    document.getElementById('search_button').disabled = false;
                    break;
                case 'update':
                    parser = new DOMParser();
                    xmlDoc = parser.parseFromString(message.xml, "text/xml");
                    let disassemblerNode = xmlDoc.getElementsByTagName("disassembler")[0];
                    console.log(disassemblerNode);
                    let temp = [];
                    let address = [];
                    let code = [];
                    let ins = [];
                    for (let x = 0; x < disassemblerNode.childNodes.length; x++) {
                        let node = disassemblerNode.childNodes[x];
                        if (node.nodeType == Node.ELEMENT_NODE) {
                            temp = node.firstChild.nodeValue.split('!');
                            if (message.searchState) {
                                let c = temp[2];
                                let f = $('#search_ins').val();
                                if (c != null && c.includes(f)) {
                                    address[x] = temp[0];
                                    code[x] = temp[1];
                                    ins[x] = temp[2];
                                }
                            } else {
                                address[x] = temp[0];
                                code[x] = temp[1];
                                ins[x] = temp[2];
                            }
                        }
                    }
                    var list = [{
                        class: '.clickAddress',
                        value: address
                    }, {
                        class: '.bytesColumn',
                        value: code
                    }, {
                        class: '.instructionColumn',
                        value: ins
                    }];
                    for (let x = 0; x < list.length; x++) {
                        test = document.querySelectorAll(list[x].class);
                        let i = 0;
                        let array = list[x].value;

                        test.forEach(element => {
                            if (array[i] == null) {
                                i++;
                            }

                            element.textContent = array[i];
                            i++;
                        });
                    }
                    break;
            }
        });


        function disassemble() {
            vscode.postMessage({
                command: 'disassemble',
                address: $('#address').val()
            });
        }

        function search_ins() {
            let a = $('#startAddress').val();
            let b = $('#endAddress').val();

            vscode.postMessage({
                command: 'search',
                address: $('#startAddress').val(),
                range: $('#endAddress').val() - $('#startAddress').val()
            });
        }

        function clickSearch(x) {
            
            a = document.getElementById(x).textContent;
            a = "0x" + a;
            document.getElementById('address').value = a;
            vscode.postMessage({
                command: 'disassemble',
                address: a
            });
        }

        function dispOutRange(){


        }

        var address = 0;
        for (x = 0; x < 100; x++) {
            $('#data').html($('#data').html() +
                `
			<div class="row">
				<div class="col-3 offsetColumn">
					<a href="#" onclick="return clickSearch(` + x +`);"class = "clickAddress" id = "` + x +`" >` + address.toString(16).padStart(8, '0') + `</a>
				</div>
				<div class="col-3 bytesColumn">
					<span>` + Math.floor(Math.random() * 100).toString(16).padStart(2, '0') + `</span>
					<span>` + Math.floor(Math.random() * 100).toString(16).padStart(2, '0') + `</span>
					<span>` + Math.floor(Math.random() * 100).toString(16).padStart(2, '0') + `</span>
				</div>
				<div class="col-6 instructionColumn">
					addi x0,x1,x2
				</div>
			</div>
			`
            );
            address += 2;
        }
    </script>
</body>

</html>